// Load dts shapes and merge animations
datablock TSShapeConstructor(Scorpion2NEWDts)
{
	baseShape  = "./Scorpion24.dts";
	sequence0  = "./sc_root.dsq root";

	sequence1  = "./sc_runNEW.dsq run";
	sequence2  = "./sc_walk.dsq walk";
	sequence3  = "./sc_back.dsq back";
	sequence4  = "./sc_side.dsq side";

	sequence5  = "./sc_crouch.dsq crouch";
	sequence6  = "./sc_crouchRun.dsq crouchRun";
	sequence7  = "./sc_crouchBack.dsq crouchBack";
	sequence8  = "./sc_crouchSide.dsq crouchSide";

	sequence9  = "./sc_root.dsq look";
	sequence10 = "./sc_headside.dsq headside";
	sequence11 = "./sc_root.dsq headUp";

	sequence12 = "./sc_jump.dsq jump";
	sequence13 = "./sc_jump.dsq standjump";
	sequence14 = "./sc_fall.dsq fall";
	sequence15 = "./sc_root.dsq land";

	sequence16 = "./sc_root.dsq armAttack";
	sequence17 = "./sc_root.dsq armReadyLeft";
	sequence18 = "./sc_root.dsq armReadyRight";
	sequence19 = "./sc_root.dsq armReadyBoth";
	sequence20 = "./sc_root.dsq spearready";  
	sequence21 = "./sc_root.dsq spearThrow";

	sequence22 = "./sc_root.dsq talk";  

	sequence23 = "./sc_death1.dsq death1"; 
	
	sequence24 = "./sc_root.dsq shiftUp";
	sequence25 = "./sc_root.dsq shiftDown";
	sequence26 = "./sc_root.dsq shiftAway";
	sequence27 = "./sc_root.dsq shiftTo";
	sequence28 = "./sc_root.dsq shiftLeft";
	sequence29 = "./sc_root.dsq shiftRight";
	sequence30 = "./sc_root.dsq rotCW";
	sequence31 = "./sc_root.dsq rotCCW";

	sequence32 = "./sc_root.dsq undo";
	sequence33 = "./sc_attack2.dsq plant";

	sequence34 = "./sc_root.dsq sit";

	sequence35 = "./sc_root.dsq wrench";

   sequence36 = "./sc_attack2.dsq activate";
   sequence37 = "./sc_attack2.dsq activate2";

   sequence38 = "./sc_root.dsq leftrecoil";

	//Scorpion2 sting animations
   sequence39 = "./sc_stingREADY.dsq stingReady";
   sequence40 = "./sc_stingNEW.dsq sting";
};    

//datablock AudioProfile(Scorpion2JumpSound)
//{
//   fileName = "jump.wav";
//   description = AudioClose3d;
//   preload = true;
//};
//datablock DebrisData( Scorpion2Debris )
//{
//   explodeOnMaxBounce = false;

//   elasticity = 0.15;
//   friction = 0.5;

//   lifetime = 4.0;
//   lifetimeVariance = 0.0;

//   minSpinSpeed = 40;
//   maxSpinSpeed = 600;

//   numBounces = 5;
//   bounceVariance = 0;

//   staticOnMaxBounce = true;
//   gravModifier = 1.0;

//   useRadiusMass = true;
//   baseRadius = 1;

//   velocity = 20.0;
//   velocityVariance = 12.0;
//};

datablock fxDTSBrickData (BrickScorpion2Bot_HoleSpawnData)
{
	brickFile = "Add-ons/Bot_Hole/8xSpawn.blb";
	category = "Special";
	subCategory = "Holes";
	uiName = "Scorpion2 Hole";
	iconName = "Add-Ons/Bot_BugMod1/icon_Scorpion2";

	bricktype = 2;
	cancover = 0;
	orientationfix = 1;
	indestructable = 1;

	isBotHole = 1;
	holeBot = "Scorpion2HoleBot";
};
         
datablock PlayerData(Scorpion2HoleBot : PlayerStandardArmor)
{
//	renderFirstPerson = true;
//    emap = false;
	
//	category = Armor;
	shapeFile = "./Scorpion24.dts";
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	maxItems   = 10;		//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;

	maxDamage = 125;
	runforce = 30 * 3000;
	maxForwardSpeed = 13;
	maxBackwardSpeed = 8;
	maxSideSpeed = 9.5;
	jumpsound = "";

	maxForwardCrouchSpeed = 4;
	maxBackwardCrouchSpeed = 3;
	maxSideCrouchSpeed = 3;

	boundingBox				= vectorScale("3.6 3.6 1.4", 4); //"3.6 3.6 2.4";
	crouchBoundingBox		= vectorScale("3.6 3.6 1.0", 4); //"3.6 3.6 2.4";
	proneBoundingBox		= vectorScale("3.6 3.6 1.4", 4); //"2.5 2.5 2.4";

	mass = 3000;	//250
	drag = 0.01;	//0.45

	jumpForce = 13 * 3000; //7.3 * 850;
    jumpDelay = 0.1;

//	maxStepHeight = 1.4;	//0.5

//        minImpactSpeed = 160;
//        speedDamageScale = 4.8;

	uiName = "B1 Scorpion Lv 1";
	rideable = false;
	canRide = false;
	paintable = true;
	numMountPoints = 0;

	isLargeEnemy = 1;

    useCustomPainEffects = true;
	PainHighImage = "PainHighImage";
	PainMidImage  = "PainMidImage";
	PainLowImage  = "PainLowImage";
	PainSound           = ""; //Scorpion2PainSound;
	DeathSound          = ""; //Scorpion2DeathSound;

	//Hole Attributes

	isHoleBot = 1;

	//Spawning option
	hSpawnTooClose = 0;//Doesn't spawn when player is too close and can see it
	  hSpawnTCRange = 8;//above range, set in brick units
	hSpawnClose = 0;//Only spawn when close to a player, can be used with above function as long as hSCRange is higher than hSpawnTCRange
	  hSpawnCRange = 32;//above range, set in brick units

	hType = Scorpion2; //Enemy,Friendly, Neutral
	  hNeutralAttackChance = 100; //0 to 100, Chance that this type will attack neutral bots, ie horses/vehicles/civilians
	//can have unique types, nazis will attack zombies but nazis will not attack other bots labeled nazi
	hName = "Scorpion2";//cannot contain spaces
	hTickRate = 3000;
	
	//Wander Options
	hWander = 1;//Enables random walking
	  hSmoothWander = 1;//This is in addition to regular wander, makes them walk a bit longer, and a bit smoother
	  hReturnToSpawn = 1;//Returns to spawn when too far
	  hSpawnDist = 48;//Defines the distance bot can travel away from spawnbrick
	  hGridWander = 0;//Locks the bot to a grid, overwrites other settings
	
	//Searching options
	hSearch = 1;//Search for Players
	  hSearchRadius = 96;//in brick units	//64
	  hSight = 1;//Require bot to see player before pursuing
	  hStrafe = 1;//Randomly strafe while following player
	hSearchFOV = 0;//if enabled disables normal hSearch
	  hFOVRange = 0.7; // determines the angle we can see the player at, 0.7 is about normal fov for players, if 0 we can see all in front, if 1 we could only see someone perfectly ahead, can be negative
	  // hFOVRadius = 6; // no longer used, we now use searchRadius
	  hHearing = 1;//If it hears a player it'll look in the direction of the sound

	  hAlertOtherBots = 0;//Alerts other bots when he sees a player, or gets attacked

	//Attack Options
	hMelee = 1;//Melee
	  hAttackDamage = 30;//Melee Damage		//40
	hShoot = 1;
	  hWep = "ScorpStingItem";
	  hShootTimes = 1;//Number of times the bot will shoot between each tick
	  hMaxShootRange = 22;//The range in which the bot will shoot the player	//32
	  hAvoidCloseRange = 0;//
		hTooCloseRange = 7;//in brick units

	//Misc options
	hActivateDirection = 0; // 0 1 2, determines the direction you have to face the bot to activate him, both, front back
	hMoveSlowdown = 0; // bool, determines wether the bot will slow down when following enemies
	hAvoidObstacles = 1;
	hSuperStacker = 0;//When enabled makes the bots stack a bit better, in other words, jumping on each others heads to get to a player
	hSpazJump = 0;//Makes bot jump when the user their following is higher than them

	hAFKOmeter = 1;//Determines how often the bot will wander or do other idle actions, higher it is the less often he does things

	hIdle = 1;// Enables use of idle actions, actions which are done when the bot is not doing anything else
	  hIdleAnimation = 0;//Plays random animations/emotes, sit, click, love/hate/etc
	  hIdleLookAtOthers = 1;//Randomly looks at other players/bots when not doing anything else
	    hIdleSpam = 0;//Makes them spam click and spam hammer/spraycan
	  hSpasticLook = 1;//Makes them look around their environment a bit more.
	hEmote = 0;

	//Old Zombie Mod code

//	ZombieTeam = "Scorpion2s";
//	attackpower = 40;
//	BrickKillRadius = 2;
//	BrickDestroyMaxVolume = 150;
//	BrickMaxJumpHeight = 10;
//	FollowAnim = "ArmReadyBoth";
//	NoBloodyHands = 1;
//	DoNotZombify = 1;
//	chance = 90;
//	SearchRadius = 50;
//	SpecialAttack = 0;
//	zDeathSound = "ZTankDiesound";
//	ignorePipeBombs = 1;

};
//function Scorpion2HoleBot::ondisabled(%this,%obj)
//{
//	parent::ondisabled(%this,%obj);
//	ZombieDefault::ondisabled(%this,%obj);
//}
//function Scorpion2HoleBot::onCollision(%this, %obj, %col, %fade, %pos, %norm)
//{
//	parent::oncollision(%this, %obj, %col, %fade, %pos, %norm);
//	ZombieDefault::onCollision(%this, %obj, %col, %fade, %pos, %norm);
//	if(IsInMinigame(%obj) && IsInSameMinigame(%col,%obj) && %obj.getstate() !$= "Dead" && %obj.spawnbrick.getgroup().client.minigame.EnableZombies == 1)
//	{
//		%col.applyimpulse(%col.getposition(),vectoradd(vectorscale(%obj.getforwardvector(),0),"0 0 0"));
//	}
//	if(IsInMinigame(%obj) && MinigameIncludesPlayerBricks(%col) && %col.iszombie && %obj.getstate() !$= "Dead")
//	{
//		%col.applyimpulse(%col.getposition(),vectoradd(vectorscale(%obj.getforwardvector(),0),"0 0 0"));
//		%obj.playthread(2,activate2);
//	}
//}
//function Scorpion2HoleBot::onMount(%a,%player,%vehicle,%d,%e,%f)
//{
//	ZombieDefault::onMount(%a,%player,%vehicle,%d,%e,%f);
//	parent::onMount(%a,%player,%vehicle,%d,%e,%f);
//}
//function Scorpion2HoleBot::onUnMount(%a,%player,%vehicle,%d,%e,%f)
//{
//	ZombieDefault::onUnMount(%a,%player,%vehicle,%d,%e,%f);
//	parent::onUnMount(%a,%player,%vehicle,%d,%e,%f);
//}
//function Scorpion2HoleBot::onAdd(%this,%obj)
//{
//	parent::onAdd(%this,%obj);
//	ZombieDefault::onAdd(%this,%obj);
//}
function Scorpion2HoleBot::onAdd(%this,%obj)
{
	armor::onAdd(%this,%obj);

	%color = getRandom(0,1);
	if(%color == 0)
		%obj.chestColor = "0.761 0.749 0.530 1";
	if(%color == 1)
		%obj.chestColor = "0.685 0.547 0.357 1";

	GameConnection::ApplyBodyParts(%obj);
	GameConnection::ApplyBodyColors(%obj);

//	schedule(15,0,recolorbug,%obj);
	//%obj.mountimage(gunimage,0);
}

