//Sp_Poison.cs


//effects
datablock ParticleData(SpiderBiteHitParticle)
{
	dragCoefficient      = 2;
	gravityCoefficient   = 1.0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	spinRandomMin 	     = -90;
	spinRandomMax 		= 90;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/dot";
	colors[0]     = "0.0 0.9 0.0 0.7";
	colors[1]     = "0.0 0.4 0.0 0.1";
	sizes[0]      = 0.2;
	sizes[1]      = 0.02;
	times[0]	  = 0.0;
	times[1]	  = 1.0;

};

datablock ParticleEmitterData(SpiderBiteHitEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 1;
   ejectionVelocity = 3;
   velocityVariance = 2.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SpiderBiteHitParticle";

   uiName = "Spider Poison";
};

datablock ExplosionData(SpiderBiteExplosion)
{
   explosionShape = "base/data/shapes/empty.dts";
   lifeTimeMS = 500;

   soundProfile = swordHitSound;

   particleEmitter = SpiderBiteHitEmitter;
   particleDensity = 15;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "1.0 1.0 1.0";
   camShakeAmp = "20.0 25.0 10.0";
   camShakeDuration = 0.1;
   camShakeRadius = 8.0;

//	impulseRadius = 2;
//	impulseForce = 1500;

//	damageRadius = 0.01;
//	radiusDamage = 0.01;
};


//projectile
AddDamageType("Spiderbite",   '<bitmap:add-ons/Bot_BugMod1/CI_spiderbite> %1',    '%2 <bitmap:add-ons/Bot_BugMod1/CI_spiderbite> %1',0.75,1);
datablock ProjectileData(SpiderBiteProjectile)
{
   directDamage        = 15;
   directDamageType  = $DamageType::Spiderbite;
   radiusDamageType  = $DamageType::Spiderbite;
   explosion           = SpiderBiteExplosion;

	impactImpulse	   = 0;
	verticalImpulse	   = 0;		//200

   muzzleVelocity      = 70;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Spider Poison";

	//Poison stuff
	poison = 1;
	poisonSound = 1;
	poisonImage = PoisonStatusPlayerImage;
	poisonChance = 100;					//Chance to poison victim (100 for always)
	poisonType = "SpiderPoison";		//Example: "SpiderPoison", used for immunity checks and curing of specific poisons
	poisonDamage = 10;					//Do you need an example here? >_>
	poisonMinHealth = 0;				//Poison stops when it reaches this amount of health. (0 to kill :D)
	poisonPulseDelay = 1000;			//Delay between pulses
	poisonMaxPulses = 4;				//Maximum amount of pulses
	poisonOverwrite = 2;
};


//////////
// item //
//////////
datablock ItemData(SpiderBiteItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	// Basic Item Properties
	shapeFile = "base/data/shapes/empty.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;

	//gui stuff
	uiName = "Spider Poison";
	iconName = "./Icon_SpiderBite";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	// Dynamic properties defined by the scripts
	image = SpiderBiteImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(SpiderBiteImage)
{
   // Basic Item properties
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = SpiderBiteProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = false;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
//	stateSound[0]                    = swordDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

//	stateName[2]			= "PreFire";
//	stateScript[2]                  = "onPreFire";
//	stateAllowImageChange[2]        = false;
//	stateTimeoutValue[2]            = 0.1;
//	stateTransitionOnTimeout[2]     = "Fire";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Recharge";
	stateTimeoutValue[2]            = 0.1;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
//	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]		= true;

//	stateName[4]			= "CheckFire";
//	stateTransitionOnTriggerUp[4]	= "StopFire";
//	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[3]                    = "Recharge";
	stateTransitionOnTimeout[3]     = "Ready";
	stateTimeoutValue[3]            = 0.5;
	stateAllowImageChange[3]        = false;
	stateWaitForTimeout[3]			= true;
//	stateSequence[3]                = "StopFire";
	stateScript[3]                  = "onStopFire";


};

function SpiderBiteImage::onFire(%this, %obj, %slot)
{
	    if(%obj.getDamagePercent() < 1.0)
			%obj.playthread(2, activate);
		Parent::onFire(%this,%obj,%slot);
}

//function SpiderBiteProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
//{

//	%damageType = $DamageType::Direct;
//	if(%this.DirectDamageType)
//		%damageType = %this.DirectDamageType;

//	%scale = getWord(%obj.getScale(), 2);
//	%directDamage = %this.directDamage * %scale	
//	%col.damage(%obj, %pos, %directDamage, %damageType); //applies damage

//	if((%col.getType() & $TypeMasks::PlayerObjectType) && %col.getstate !$= "Dead")
//	{
//		if(%col.NoPoison == 1 || %col.getDatablock().NoPoison == 1)
//		{
//			//%col.damage(%obj, %pos, %directDamage, %damageType); //applies damage
//		}
//		else
//		{
//			for(%i = 2; %i < 7; %i++)
//			{
//				%img = %col.getMountedImage(%i);
//				if(%img == PoisonStatusPlayerImage.getID())
//				{
//					//%col.damage(%obj, %pos, %directDamage, %damageType);
//					return;
//				}
//				if(%img < 1)
//				{
//					%col.PoisonType = "SpiderPoison";
//					%col.mountImage(PoisonStatusPlayerImage, %i);
//					//%col.damage(%obj, %pos, %directDamage, %damageType);
//					return;
//				}
//			}
//		}
//	}
//	else
//	{
//		//%col.damage(%obj, %pos, %directDamage, %damageType);
//	}
//}
