//Weapon_Wm_Attack.cs

datablock AudioProfile(WormSmashsound)
{
	//This sound is from the old Gamemode_zombie mod, created by Rotondo
	filename = "./worm_smash.wav";
	description = AudioClose3d;
	preload = true;
};

//effects
datablock ParticleData(WormSmashHitParticle)
{
	dragCoefficient      = 2;
	gravityCoefficient   = 0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	spinRandomMin 	     = -90;
	spinRandomMax 		= 90;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/dot";
	colors[0]     = "0.5 0.17 0.0 0.9";
	colors[1]     = "0.2 0.2 0.2 0.1";
	sizes[0]      = 0.6;
	sizes[1]      = 0.1;
	times[0]	  = 0.0;
	times[1]	  = 1.0;

	useInvAlpha = true;
};

datablock ParticleEmitterData(WormSmashHitEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 1;
   ejectionVelocity = 3;
   velocityVariance = 2.0;
   ejectionOffset   = 1;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "WormSmashHitParticle";

   uiName = "Worm Smash";
};

datablock ExplosionData(WormSmashExplosion : BugBiteExplosion)
{
   explosionShape = "base/data/shapes/empty.dts";
   lifeTimeMS = 500;

   soundProfile = WormSmashsound;

   particleEmitter = WormSmashHitEmitter;
   particleDensity = 15;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "2.0 2.0 2.0";
   camShakeAmp = "15.0 15.0 5.0";
   camShakeDuration = 0.3;
   camShakeRadius = 10.0;

   	impulseRadius = 2;
	impulseForce = 2800;	//3500

	damageRadius = 0.01;
	radiusDamage = 0.01;

};


//projectile
AddDamageType("Wormsmash",   '<bitmap:add-ons/Bot_BugMod1/CI_Wormsmash> %1',    '%2 <bitmap:add-ons/Bot_BugMod1/CI_Wormsmash> %1',0.75,1);
datablock ProjectileData(WormSmashProjectile) // : BugBitePtojectile)
{
   directDamage        = 36;
   directDamageType  = $DamageType::Wormsmash;
   radiusDamageType  = $DamageType::Wormsmash;
   explosion           = WormSmashExplosion;

	impactImpulse	   = 200;
	verticalImpulse	   = 500;

   muzzleVelocity      = 80;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

//   hasLight    = false;
//   lightRadius = 3.0;
//   lightColor  = "0 0 0.5";

   uiName = "Worm Smash";
};


//////////
// item //
//////////
datablock ItemData(WormSmashItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	// Basic Item Properties
	shapeFile = "base/data/shapes/empty.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;

	//gui stuff
	uiName = "Worm Smash";
	iconName = "./Icon_WormBash";
//	doColorShift = false;
//	colorShiftColor = "0.471 0.471 0.471 1.000";

	// Dynamic properties defined by the scripts
	image = WormSmashImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(WormSmashImage)
{
   // Basic Item properties
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = WormSmashProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = false;

   //casing = " ";
//   doColorShift = false;
//   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.2;
	stateTransitionOnTimeout[0]      = "Ready";
//	stateSound[0]                    = swordDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Recharge";
	stateTimeoutValue[2]            = 0.1;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
//	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]		= true;

//	stateName[4]			= "CheckFire";
//	stateTransitionOnTriggerUp[4]	= "StopFire";
//	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[3]                    = "Recharge";
	stateTransitionOnTimeout[3]     = "Ready";
	stateTimeoutValue[3]            = 0.7;
	stateAllowImageChange[3]        = false;
	stateWaitForTimeout[3]			= true;
//	stateSequence[3]                = "StopFire";
	stateScript[3]                  = "onStopFire";

};

function WormSmashImage::onFire(%this, %obj, %slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playthread(2, plant);
	Parent::onFire(%this,%obj,%slot);
}
